﻿using EF_CodeFirst_Delete_MVC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EF_CodeFirst_Delete_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            using (CustomerDBContext context = new CustomerDBContext())
            {
                if (context.Customers.ToList().Count == 0)
                {
                    // Adding Dummy data.
                    context.Customers.AddRange(new List<Customer>() {
                        new Customer() { Name = "John Hammond", Country = "United States" },
                        new Customer() { Name = "Mudassar Khan", Country = "India" },
                        new Customer() { Name = "Suzanne Mathews", Country = "France" },
                        new Customer() { Name = "Robert Schidner", Country = "Russia" }
                    });

                    context.SaveChanges();
                }
            }

            return View();
        }

        [HttpPost]
        public ActionResult Index(Customer customer)
        {
            using (CustomerDBContext context = new CustomerDBContext())
            {
                Customer deletedCustomer = (from c in context.Customers
                                            where c.CustomerId == customer.CustomerId
                                            select c).FirstOrDefault();

                if (deletedCustomer != null)
                {
                    context.Customers.Remove(deletedCustomer);
                    context.SaveChanges();
                    ViewBag.Message = "Customer record deleted.";
                }
                else
                {
                    ViewBag.Message = "Customer not found.";
                }
            }

            return View(customer);
        }
    }
}